"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SqliteTools = void 0;
var sqlite_1 = __importStar(require("@databases/sqlite"));
var SqliteTools = /** @class */ (function () {
    function SqliteTools(path) {
        this.path = path;
    }
    SqliteTools.prototype.withDB = function (callback) {
        return __awaiter(this, void 0, void 0, function () {
            var db;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        db = sqlite_1.default(this.path);
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, , 2, 4]);
                        return [2 /*return*/, callback(db)];
                    case 2: return [4 /*yield*/, db.dispose()];
                    case 3:
                        _a.sent();
                        return [7 /*endfinally*/];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    SqliteTools.prototype.ensureTableExists = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.withDB(function (db) { return __awaiter(_this, void 0, void 0, function () {
                            var req;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        req = sqlite_1.sql(templateObject_1 || (templateObject_1 = __makeTemplateObject(["CREATE TABLE IF NOT EXISTS listeners\n                    (\n                      address TEXT NOT NULL,\n                      customfields TEXT DEFAULT '[]' NOT NULL,\n                      timeloop INTEGER DEFAULT 300 NOT NULL,\n                      last_entries_links TEXT DEFAULT '[]' NOT NULL,\n                      PRIMARY KEY (address),\n                      CHECK(timeloop >= 0)\n                    );"], ["CREATE TABLE IF NOT EXISTS listeners\n                    (\n                      address TEXT NOT NULL,\n                      customfields TEXT DEFAULT '[]' NOT NULL,\n                      timeloop INTEGER DEFAULT 300 NOT NULL,\n                      last_entries_links TEXT DEFAULT '[]' NOT NULL,\n                      PRIMARY KEY (address),\n                      CHECK(timeloop >= 0)\n                    );"])));
                                        return [4 /*yield*/, db.query(req)];
                                    case 1:
                                        _a.sent();
                                        return [2 /*return*/];
                                }
                            });
                        }); })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    SqliteTools.prototype.fetchAll = function () {
        return __awaiter(this, void 0, void 0, function () {
            var rows;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.withDB(function (db) { return __awaiter(_this, void 0, void 0, function () {
                            var req;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        req = sqlite_1.sql(templateObject_2 || (templateObject_2 = __makeTemplateObject(["SELECT *\n                    FROM listeners"], ["SELECT *\n                    FROM listeners"])));
                                        return [4 /*yield*/, db.query(req)];
                                    case 1: return [2 /*return*/, _a.sent()];
                                }
                            });
                        }); })];
                    case 1:
                        rows = _a.sent();
                        return [2 /*return*/, rows.map(function (row) { return ({
                                address: row["address"],
                                customfields: JSON.parse(row["customfields"]),
                                timeloop: row["timeloop"],
                                lastEntriesLinks: JSON.parse(row["last_entries_links"]),
                            }); })];
                }
            });
        });
    };
    SqliteTools.prototype.insertListener = function (listener) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.withDB(function (db) { return __awaiter(_this, void 0, void 0, function () {
                            var req;
                            var _a, _b;
                            return __generator(this, function (_c) {
                                switch (_c.label) {
                                    case 0:
                                        req = sqlite_1.sql(templateObject_3 || (templateObject_3 = __makeTemplateObject(["INSERT INTO listeners (address, timeloop, customfields, last_entries_links)\n                    VALUES (", ",\n                      ", ",\n                      ", ",\n                      ", ")"], ["INSERT INTO listeners (address, timeloop, customfields, last_entries_links)\n                    VALUES (", ",\n                      ", ",\n                      ", ",\n                      ", ")"])), listener.address, listener.timeloop, JSON.stringify((_a = listener.customfields) !== null && _a !== void 0 ? _a : []), JSON.stringify((_b = listener.lastEntriesLinks) !== null && _b !== void 0 ? _b : []));
                                        return [4 /*yield*/, db.query(req)];
                                    case 1:
                                        _c.sent();
                                        return [2 /*return*/];
                                }
                            });
                        }); })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    SqliteTools.prototype.deleteListener = function (adr) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.withDB(function (db) { return __awaiter(_this, void 0, void 0, function () {
                            var req;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        req = sqlite_1.sql(templateObject_4 || (templateObject_4 = __makeTemplateObject(["DELETE FROM listeners\n                    WHERE address = ", ""], ["DELETE FROM listeners\n                    WHERE address = ", ""])), adr);
                                        return [4 /*yield*/, db.query(req)];
                                    case 1:
                                        _a.sent();
                                        return [2 /*return*/];
                                }
                            });
                        }); })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    SqliteTools.prototype.updateAll = function (listeners) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.withDB(function (db) { return __awaiter(_this, void 0, void 0, function () {
                            var _this = this;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0: return [4 /*yield*/, db.tx(function (transaction) { return __awaiter(_this, void 0, void 0, function () {
                                            var listeners_1, listeners_1_1, listener, req, e_1_1;
                                            var e_1, _a;
                                            return __generator(this, function (_b) {
                                                switch (_b.label) {
                                                    case 0:
                                                        _b.trys.push([0, 5, 6, 7]);
                                                        listeners_1 = __values(listeners), listeners_1_1 = listeners_1.next();
                                                        _b.label = 1;
                                                    case 1:
                                                        if (!!listeners_1_1.done) return [3 /*break*/, 4];
                                                        listener = listeners_1_1.value;
                                                        req = sqlite_1.sql(templateObject_5 || (templateObject_5 = __makeTemplateObject(["UPDATE listeners\n                      SET last_entries_links = ", "\n                      WHERE address = ", ""], ["UPDATE listeners\n                      SET last_entries_links = ",
                                                            "\n                      WHERE address = ", ""])), JSON.stringify(listener.lastEntriesLinks), listener.address);
                                                        return [4 /*yield*/, transaction.query(req)];
                                                    case 2:
                                                        _b.sent();
                                                        _b.label = 3;
                                                    case 3:
                                                        listeners_1_1 = listeners_1.next();
                                                        return [3 /*break*/, 1];
                                                    case 4: return [3 /*break*/, 7];
                                                    case 5:
                                                        e_1_1 = _b.sent();
                                                        e_1 = { error: e_1_1 };
                                                        return [3 /*break*/, 7];
                                                    case 6:
                                                        try {
                                                            if (listeners_1_1 && !listeners_1_1.done && (_a = listeners_1.return)) _a.call(listeners_1);
                                                        }
                                                        finally { if (e_1) throw e_1.error; }
                                                        return [7 /*endfinally*/];
                                                    case 7: return [2 /*return*/];
                                                }
                                            });
                                        }); })];
                                    case 1:
                                        _a.sent();
                                        return [2 /*return*/];
                                }
                            });
                        }); })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    return SqliteTools;
}());
exports.SqliteTools = SqliteTools;
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5;
