import { ListenerRss } from "listener-rss";
import { DatabaseConnection } from "@databases/sqlite";
export declare class SqliteTools {
    path?: string;
    constructor(path?: string);
    withDB<Type>(callback: (db: DatabaseConnection) => Promise<Type>): Promise<Type>;
    ensureTableExists(): Promise<void>;
    fetchAll(): Promise<ListenerRss.Config[]>;
    insertListener(listener: ListenerRss.Config): Promise<void>;
    deleteListener(adr: string): Promise<void>;
    updateAll(listeners: ListenerRss.Config[]): Promise<void>;
}
//# sourceMappingURL=sqlite-tools.d.ts.map